#include <stdio.h>
#include <math.h>
FILE *fp;
char a[80],f1[60],f2[20],c1[14],c2[14],f10;
char head[72][80],c=37;
double u1,v1,x1,z1,x[4],y[4],ra,de,epoch;
int  w[4];
char color;
char t[80];
int  n1=4096,n2=4032;
float xx[4]={ 193.7,186.7,-181.5,-195.5 };
float yy[4]={ -81.8,71.7, -104.8,  55.4 };
double pi,cx,cy,a8[8],b8[8];

main(int ac,char **av)
{
  int i,j,k;
  if(ac<2){ printf("\n\t******* get real coordination ********\n");
            printf("\n\t             jiang  20150110\n"); 
            printf("\n\tUsage: getcoord2 d5534.0045.fits [!]\n");
            printf("\n\t if getcoord1 fail, then:\n\n");
            exit(0);
  }
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  for(i=0;i<4;i++)w[i]=0;
  fp=fopen(av[1],"rb");
  if(fp==0){ printf("\n\tinput file not found!\n"); exit(0); }    
  fclose(fp);
  strcpy(f1,av[1]); k=strlen(f1); f1[k-5]=0; 
// if e*_1.fit existed, not do d4,e4;
  sprintf(f2,"%s_1.fit",f1); f2[0]='e'; f2[5]='?';
  sprintf(t,"ls %s >1.1",f2); system(t);
  fp=fopen("1.1","r"); fgets(a,80,fp); fclose(fp);
  k=0;
  for(j=0;j<15;j++)if(a[j]!=f2[j]){ k++; if(k==1 && j==5)f1[j]=color=a[j]; }
  if(k==1){ printf("*********\n"); goto l10; }  // d4 e4 done
  sprintf(a,"d4 %s",av[1]); system(a); // for display reason, produce all 4 e*
  fp=fopen("color","r");
  if(fp){ color=fgetc(fp); fclose(fp); f1[5]=color; }
  for(i=0;i<4;i++){ sprintf(a,"e4 %s_%d.fit",f1,i+1); 
  printf("-----%s\n",a);
  system(a); }

l10:
  f10=f1[0]; f1[0]='e';
  for(i=0;i<4;i++){ sprintf(a,"coord61 %s_%d",f1,i+1); system(a); }
  for(i=0;i<4;i++){         
    sprintf(a,"%s_%d.fit",f1,i+1);
    fp=fopen(a,"rb"); if(fp==0)continue;
    fread(head,72,80,fp); fclose(fp);
    k=indexpos(head,"A87     ",72); if(k==72)continue; 
    w[i]=1;
    head[k][67]= head[k+1][67]= head[k-7][30]=0;
    printf("%d: %s %s  seeing:%s\n",
      i+1,&head[k][46],&head[k+1][46],&head[k-7][24]);
    k=indexpos(head,"A81     ",72);
    for(j=0;j<8;j++)sscanf(&head[k++][11],"%le",&a8[j]);  
    xytoad(a8,b8);
    x1=xx[i]; z1=yy[i];
    if(i==0)x1+=n1;
    if(i==1){ x1+=n1; z1+=n2; }
    if(i==3)z1+=n2;
    xy_rad(a8[6],a8[7],x1,z1,&x[i],&y[i],1,0);
  }
  k=0; for(i=0;i<4;i++)k+=w[i];
  if(k==0){ printf(" FAIL !!, adjust telescope pointing, then...\n"); exit(0);}

  x1=z1=0.;  k=0;                   
  for(i=0;i<4;i++){         
    if(w[i]){ x1+=x[i]; z1+=y[i]; k++; }
  }
  x1/=k; z1/=k;
  toms1(x1,c1,1); toms1(z1,c2,0);
  for(i=0;i<60;i++)printf("-"); printf("\n");
  head[5][23]=head[6][23]=0;
  chs(&head[5][11],&u1);
  chs(&head[6][11],&v1);  
  k=indexpos(head,"DATE-OBS",72);
  for(i=0;i<30;i++){ c=head[k][i+8]; if(c<'0' || c>'9')c=32; a[i]=c; }
  sscanf(a,"%d %d %d",&i,&j,&k); epoch=i+(j-1)/12.+(k-1)/30./12.;
  k=epoch*10+0.5; epoch=k*.1;
  astprs2(u1,v1,2000.,&ra,&de,epoch);  toms1(ra,c1,1); toms1(de,c2,0);
  printf("OBS:  %s %s (2000.0)  %s %s (%6.1lf)\n",
  &head[5][11],&head[6][11],c1,c2,epoch);
  toms1(x1,c1,1); toms1(z1,c2,0);
  printf("CAL: %s  %s  (2000.0)",c1,c2);
  astprs2(x1,z1,2000.,&ra,&de,epoch);  toms1(ra,c1,1); toms1(de,c2,0);
  printf("  %s %s (%6.1lf)\n",c1,c2,epoch);

  x1-=u1; z1-=v1;
  x1*=3600.; z1*=3600.;  x1=-x1; z1=-z1;
  printf(" %12.2lf (%6.1lf  %6.1lf\n",x1,x1*15.,z1);
  printf("\n\tc40 %s*.fit !\n\n",f1);
}

chs(a,y)
char *a; double *y;
{
  double x;
  char b[20];
  int i,j,k;
  strncpy(b,a,20); k=strlen(b);
  j=1; for(i=0;i<k;i++){ if(b[i]==32)continue; if(b[i]=='-')j=-1; break; }
  for(i=0;i<k;i++)if(b[i]<'.' || b[i]> '9')b[i]=32;
  i=k=0; x=0.; sscanf(b,"%d %d %lf",&i,&k,&x);
  x=k/60.+x/3600.+i;
  *y=x*j;
}

toms1(aa,c,k)
double aa;           // input
char c[14];          // output
int k;               // input
{
  int  i,j;
  double a,b,x;
  a=aa;
  if(k==1){ if(a>24.)a-=24.; if(a<0.)a+=24.; }
  c[0]=32; if(a<0.){ a=-a; c[0]='-'; }
  i=a; b=(a-i)*60.;
  j=b; x=(b-j)*60.;
  if(j==60){ j=0; i++; }
  if(k==1)sprintf(&c[1],"%2.2d:%2.2d:%5.2f",i,j,x);
  if(k==0)sprintf(&c[1],"%2.2d:%2.2d:%4.1f",i,j,x);
  if(c[7]==32)c[7]='0';   if(c[8]==32)c[8]='0';
  if(c[7]=='6'){
    c[7]='0'; j++; sprintf(&c[4],"%2.2d",j);
    if(c[4]=='6'){
      c[4]='0'; i++; sprintf(&c[1],"%2.2d",i);
    }
    c[3]=':'; c[6]=':';
  }
}

astprs2(ra1, dc1, ep1, ra2, dc2, ep2)   // RA in hour, DEC in degree
double  ra1,dc1,ep1,*ra2,*dc2,ep2;      // only ra2,dc2   is output
{
  double r0[3],r1[3],p[3][3],arc;
  double r2,d2;

  arc=45./atan(1.);
  *ra2=ra1; *dc2=dc1;
  if(ep1 == ep2)return;
  r2 =ra1*15./arc; d2 =dc1/arc;
  r0[0]=cos(r2)*cos(d2); r0[1]=sin(r2)*cos(d2); r0[2]=sin(d2);
  if(ep1 != 2000.){
    astrox(ep1, p);
    r1[0] = p[0][0] * r0[0] + p[0][1] * r0[1] + p[0][2] * r0[2];
    r1[1] = p[1][0] * r0[0] + p[1][1] * r0[1] + p[1][2] * r0[2];
    r1[2] = p[2][0] * r0[0] + p[2][1] * r0[1] + p[2][2] * r0[2];
    r0[0] = r1[0]; r0[1] = r1[1]; r0[2] = r1[2];
  }
  if(ep2 != 2000.){
    astrox(ep2, p);
    r1[0] = p[0][0] * r0[0] + p[1][0] * r0[1] + p[2][0] * r0[2];
    r1[1] = p[0][1] * r0[0] + p[1][1] * r0[1] + p[2][1] * r0[2];
    r1[2] = p[0][2] * r0[0] + p[1][2] * r0[1] + p[2][2] * r0[2];
    r0[0] = r1[0];    r0[1] = r1[1];    r0[2] = r1[2];
  }
  *ra2  = atan2(r0[1], r0[0])/15.*arc;
  *dc2 = asin(r0[2])*arc;
  if(*ra2<0)*ra2+=24.;
}

astrox (epoch, p)
double epoch,p[3][3];
{
  double t,a,b,c,ca,cb,cc,sa,sb,sc,arc;
  arc=45./atan(1.);
  astjuy(epoch,&t);
  t = (t - 2451545.0) / 36525.;
  a = t * (0.6406161 + t * (0.0000839 + t * 0.0000050));
  b = t * (0.6406161 + t * (0.0003041 + t * 0.0000051));
  c = t * (0.5567530 - t * (0.0001185 + t * 0.0000116));
  ca = cos (a/arc);
  sa = sin (a/arc);
  cb = cos (b/arc);
  sb = sin (b/arc);
  cc = cos (c/arc);
  sc = sin (c/arc);
  p[0][0] = ca * cb * cc - sa * sb;
  p[1][0] = -sa * cb * cc - ca * sb;
  p[2][0] = -cb * sc;
  p[0][1] = ca * sb * cc + sa * cb;
  p[1][1] = -sa * sb * cc + ca * cb;
  p[2][1] = -sb * sc;
  p[0][2] = ca * sc;
  p[1][2] = -sa * sc;
  p[2][2] = cc;
}

astjuy (epoch,t)
double epoch,*t;
{
  double jd;
  int year,centuy;
  year = epoch - 1;
  centuy = year / 100;
  jd =1721425.5+365.*year-centuy+ year/4 + centuy/4;
  year=epoch;
  *t= jd + (epoch - year) * 365.25;
}

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

#define bok  48.
xy_rad(ac,dc,x,y,ra,de,type,k)
double ac,dc,x,y,*ra,*de;  int type,k;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  if(type==1){
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=tan(tmp)/tmp;
      xi*=tmp;  xn*=tmp;
    }
  }
  if(type==2){
    tmp=1.+bok*(xi*xi+xn*xn);

    for(i=0;i<4;i++){
      x1=xi/tmp; y1=xn/tmp;
      tmp=tan(dc);  tmp1=1.-y1*tmp;
      r1=atan(x1/cos(dc)/tmp1);
      d1=atan((y1+tmp)*cos(r1)/tmp1);
      r1+=ac;
      tmp=atan(tan(d1)/cos(r1-ac));
      x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
      y1=tan(tmp-dc);
      tmp=1.+bok*(x1*x1+y1*y1);
    }
    xi/=tmp; xn/=tmp;
  }
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc; if(tmp<0.)tmp=-tmp;
  if(tmp>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  if(k==0){ *ra/=cx; *de/=cy; }
}

toms2(aa,c,k)
double aa;           // input
char c[14];          // output
int k;               // input
/*
 *  hour or degree to char_line
 *   if k=1 (hour case) in **:**:**.***
 *       k=0 (degree       -**:**:**.**
 *       */
{
  int  i,j;
  double a,b,x;
  a=aa;
  if(k==1){ if(a>24.)a-=24.; if(a<0.)a+=24.; }
  c[0]=32; if(a<0.){ a=-a; c[0]='-'; }
  i=a; b=(a-i)*60.;
  j=b; x=(b-j)*60.;
  if(j==60){ j=0; i++; }
  if(k==1)sprintf(&c[1],"%2.2d:%2.2d:%6.3f",i,j,x);
  if(k==0)sprintf(&c[1],"%2.2d:%2.2d:%5.2f",i,j,x);
  if(c[7]==32)c[7]='0';   if(c[8]==32)c[8]='0';
  if(c[7]=='6'){
    c[7]='0'; j++; sprintf(&c[4],"%2.2d",j);
    if(c[4]=='6'){
      c[4]='0'; i++; sprintf(&c[1],"%2.2d",i);
    }
    c[3]=':'; c[6]=':';
  }
}
